/* -*- mode: C++; c-basic-offset: 2; indent-tabs-mode: nil -*- */
/*
 *  Main authors:
 *     Christian Schulte <schulte@gecode.org>
 *
 *  Copyright:
 *     Christian Schulte, 2012
 *
 *  Last modified:
 *     $Date: 2012-08-30 15:16:34 +0200 (Thu, 30 Aug 2012) $ by $Author: schulte $
 *     $Revision: 13026 $
 *
 *  This file is part of Gecode, the generic constraint
 *  development environment:
 *     http://www.gecode.org
 *
 *  Permission is hereby granted, free of charge, to any person obtaining
 *  a copy of this software and associated documentation files (the
 *  "Software"), to deal in the Software without restriction, including
 *  without limitation the rights to use, copy, modify, merge, publish,
 *  distribute, sublicense, and/or sell copies of the Software, and to
 *  permit persons to whom the Software is furnished to do so, subject to
 *  the following conditions:
 *
 *  The above copyright notice and this permission notice shall be
 *  included in all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 *  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 *  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 *  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 *  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 *  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifdef _MSC_VER

#define _CRT_RAND_S
#include <stdlib.h>

#include <gecode/support.hh>

namespace Gecode { namespace Support {

  unsigned int hwrnd(void) {
    unsigned int r;
    (void) rand_s(&r);
    return r;
  }

}}

#else

#include <gecode/support.hh>

#include <fstream>

namespace Gecode { namespace Support {

  unsigned int hwrnd(void) {
    std::fstream devrandom;
    devrandom.open("/dev/random", std::fstream::in);
    unsigned int rnd;
    devrandom.read(reinterpret_cast<char*>(&rnd),sizeof(unsigned int));
    devrandom.close();
    return rnd;
  }

}}

#endif

// STATISTICS: support-any

